apps/rp/api/urls.py
from rest_framework import routers
from .views import ArticleViewSet, ArticleSearch, ArticleTag, ArticleStatus


router = routers.DefaultRouter()

router.register(r"articles", ArticleViewSet)
router.register(r"articles-by-status/(?P<filter_status>.+)", ArticleStatus)
router.register(r"articles-by-tag/(?P<filter_tag>.+)", ArticleTag)
router.register(r"articles-search/(?P<search_keywords>.+)", ArticleSearch)

urlpatterns = router.urls

apps/rp/feeds/urls.py
from django.conf.urls import url
from .feeds import ArticlesFeed, ArticlesTagsFeed, ArticlesSearchFeed

urlpatterns = [
    url(r'^$', ArticlesFeed(filter_lang='FR'), name='articles-feed'),
    url(r'^international$', ArticlesFeed(filter_lang='EN'), name='articles-feed-international'),
    url(r'^by-tag/(?P<filter_tag>.*)', ArticlesTagsFeed()),
    url(r'^search/(?P<search_keywords>.*)', ArticlesSearchFeed())
]

apps/rp/urls.py
from django.conf.urls import url

from rp.views.articles import (ArticleListFlux, ArticleEdit,
                               ArticleDetailView, ArticleList)

urlpatterns = [
    url(
        r"^$",
        ArticleList.as_view(filter_lang='FR'),
        name="public-article-list"
    ),
    url(
        r"^international$",
        ArticleList.as_view(filter_lang='EN'),
        name="public-article-list-international"
    ),
    url(
        r"^by-tag/(?P<filter_tag>.*)",
        ArticleList.as_view(),
        name="public-article-list-tag"
    ),
    url(
        r"^article/list/(?P<filter_view>\w+)",
        ArticleListFlux.as_view(),
        name="article-list"
    ),
    url(
        r"^article/list",
        ArticleListFlux.as_view(),
        name="article-list"
    ),
    url(
        r"^article/edit/(?P<pk>\d+)",
        ArticleEdit.as_view(),
        name="article-edit"
    ),
    url(
        r"^article/view/(?P<pk>\d+)",
        ArticleDetailView.as_view(),
        name="article-view"
    ),
    url(
        r"^article/preview/(?P<pk>\d+)",
        ArticleDetailView.as_view(preview=True),
        name="article-preview"
    )
]

project/urls.py
"""
rp_new URL Configuration
"""

from django.conf import settings
from django.conf.urls import url, include
from django.conf.urls.static import static
from django.contrib import admin
from django.views.generic.base import RedirectView

# Django rest framework router
from core.routers import DefaultRouter
from rp.api.urls import router as rp_router

# Django rest framework documentation
from rest_framework.documentation import include_docs_urls


router = DefaultRouter()
router.extend(rp_router)

urlpatterns = [
    url(r"^admin/", admin.site.urls),
    url(r'^$', RedirectView.as_view(url='/rp/', permanent=False), name='index'),
    url(r'^i18n/', include('django.conf.urls.i18n')),
    url(r"^api/", include((router.urls, "api"))),
    url(r"^feeds/", include(("rp.feeds.urls", "feeds"))),
    url(r"^rp/", include(("rp.urls", "rp"))),
    url(r'^accounts/', include('allauth.urls')),
    url(r"^users/", include(('userprofile.urls', "users"))),
    url(r"^docs/api/", include_docs_urls(title="API de la revue de presse")),
]

if settings.DEBUG:
    # Serve static files in DEBUG mode
    urlpatterns += static(
        settings.MEDIA_URL,
        document_root=settings.MEDIA_ROOT
    )

    import debug_toolbar
    urlpatterns += [
        url(r'^__debug__/', include(debug_toolbar.urls)),
    ]

apps/rp/models.py
from django.db import models
from django.utils.translation import ugettext_lazy as _
from django.core import files

from taggit.managers import TaggableManager
from newspaper import Article as ArticleParser, ArticleException
from django_fsm import FSMField, transition, RETURN_VALUE

from io import BytesIO
from datetime import datetime

from rp.utils import cleanup_url


ARTICLE_SCORE_THRESHOLD = 3

STATUS_CHOICES = (
    ("NEW", _("New")),
    ("DRAFT", _("Draft")),
    ("PUBLISHED", _("Published")),
    ("REJECTED", _("Rejected"))
)

LANG_CHOICES = (
    ("FR", _("French")),
    ("EN", _("English")),
    ("NA", _("Other"))
)

URL_HELP_TEXT = """The URL should not contain any marketing tags. We
automatically strip the most known tags."""

TITLE_HELP_TEXT = """Please remove non-necessary parts such as newspapers'
names and leave only the article title."""

EXTRACTS_HELP_TEXT = """Please select short and helpful extracts from the
article content. You should aim at around 500 characters. Use bracket ellipsis
[…] to cut parts not required to understand the context."""


class Article(models.Model):
    #: Logical state (eg. article submitted, published, or rejected)
    # This is unprotected because superuser should be able to change
    # the status from the django admin interface
    status = FSMField(default='NEW', choices=STATUS_CHOICES)

    #: Original URL
    url = models.URLField("URL", help_text=URL_HELP_TEXT)

    #: Language of the webpage
    lang = models.CharField(
        _("Language"), choices=LANG_CHOICES, default="FR", max_length=5)

    #: Plain-text Opengraph metadata
    metadata = models.TextField(
        _("Opengraph metadata"), blank=True, null=True)

    #: Screenshot or banner image for the original webpage
    screenshot = models.ImageField(
        _("Article screenshot"), blank=True, null=True)

    #: Article title
    title = models.CharField(
        _("Article title"), max_length=255, default="",
        help_text=TITLE_HELP_TEXT)

    #: Short name for the website (eg. "NY Times")
    website = models.CharField(_("Website"), max_length=255, default="")

    #: Short content extracts (eg. two to three paragraphs)
    extracts = models.TextField(
        _("Content extracts"), blank=True, null=True,
        help_text=EXTRACTS_HELP_TEXT)

    #: First submission date
    created_at = models.DateTimeField(_("Creation date"), auto_now_add=True)

    #: Name of the user who first submitted the article
    created_by = models.CharField(max_length=255, null=True)

    #: Last update date
    updated_at = models.DateTimeField(_("Last update"), auto_now=True)

    #: Published date
    published_at = models.DateTimeField(
        _("Publication date"), blank=True, null=True)

    #: original state (error code when trying to fetch datas)
    original_status = models.IntegerField(_("Original status"), default="200")

    #: priority: True if article have priority
    priority = models.BooleanField(default=False)

    #: List of tags used to add subject and topics to an article
    tags = TaggableManager(blank=True)

    #: Score of the article, modifiedby upvote and downvote methods
    score = models.IntegerField(default=0)

    #: If the publication is "archived" (not visible by default from the public
    #: feeds), this flag is set to True
    archive = models.BooleanField(_("Article archived"), default=False)

    #: If the article is quoting something LQDN said or wrote
    quote = models.BooleanField(_("Article directly quotes us"),
                                default=False)

    #: If the article speaks about something LQDN did or wrote
    speak = models.BooleanField(_("Article speaks of us"), default=False)

    class Meta:
        verbose_name = _("Article")
        verbose_name_plural = _("Articles")

        permissions = (
            ("can_change_status", "Can change article status"),
            ("can_change_priority", "Can change article priority"),
            ("can_vote", "Can vote articles"),
            ("can_edit", "Can edit articles")
        )

        #: By default, sort articles by published, updated, or created date
        ordering = ["-published_at", "-updated_at", "-created_at"]

    def __str__(self):
        """ Returns article title. Or URL if title is empty"""
        return self.title if self.title else self.url

    # Finite state logic
    @transition(field=status, source='DRAFT', target='PUBLISHED',
                permission="rp.can_change_status")
    def publish(self):
        """ Publish a complete draft. """
        self.published_at = datetime.now()

    @transition(field=status, source=['NEW', 'REJECTED'], target='DRAFT',
                permission="rp.can_change_status")
    def recover(self):
        """ Force an article to be considered as _DRAFT_. """
        pass

    @transition(field=status, source=['NEW', 'DRAFT'], target='REJECTED',
                permission="rp.can_change_status")
    def reject(self):
        """ Manual rejection of the article. """
        pass

    @transition(field=status, source='DRAFT', target='DRAFT',
                permission="rp.can_change_priority")
    def set_priority(self):
        """ Set the boolean priority of an article to True.
        The article must be a _DRAFT_"""
        self.priority = True

    @transition(field=status, source='DRAFT', target='DRAFT',
                permission="rp.can_change_priority")
    def unset_priority(self):
        """ Set the boolean priority of an article to False. 
        The article must be a _DRAFT_."""
        self.priority = False

    @transition(field=status, source='DRAFT', target='DRAFT')
    @transition(field=status, source='NEW',
                target=RETURN_VALUE('NEW', 'DRAFT'), permission="rp.can_vote")
    def upvote(self):
        """
        Upvote the article score for the given user and remove previous votes.
        If the score crosses the threshold ```ARTICLE_SCORE_THRESHOLD```,
        automatically moves the article from _NEW_ to _DRAFT_.
        """
        self.score += 1
        if self.score >= ARTICLE_SCORE_THRESHOLD:
            return 'DRAFT'
        else:
            return self.status

    @transition(field=status, source='PUBLISHED', target='DRAFT',
                permission="rp.can_change_status")
    def unpublish(self):
        """
        Unpublish an article from the RP, and reset it back to a _DRAFT_.
        """
        pass

    @transition(field=status, source='NEW', target='NEW',
                permission="rp.can_vote")
    @transition(field=status, source='DRAFT', target='DRAFT',
                permission="rp.can_vote")
    def downvote(self, by=None):
        """
        Downvote the article score for the given user and remove previous
        votes. Draft articles can be downvoted but will not be moved back in
        the _NEW_ queue.
        """
        self.score -= 1

    @classmethod
    def add_new_url(by=None, **data):
        """ Manually add a new article from its URL.
        Verify if the article has not been submitted before and automatically
        upvote for the given user if applicable.
        """
        import requests

        url = cleanup_url(data.pop('url', None))
        tags = data.pop('tags', None)
        (article, created) = Article.objects.get_or_create(url=url,
                                                           defaults=data)

        # Always upvote the article, except if it was rejected before.
        # It's either a new one, and adding it count as a vote, or it existed
        # already, and this is a vote.
        if article.status == "REJECTED":
            return None
        article.upvote()

        # Let's add the tags
        if tags:
            article.tags.add(*tags)
            article.save()
        try:
            r = requests.get(url, timeout=0.5)
            article.original_status = r.status_code
        except Exception:
            # If the domain name can't be found, we're not even getting into
            # the HTTP protocol So, let's get a specific status for that,
            # one that can be easily identified.
            article.original_status = 600

        article.url = url
        article.save()
        article.refresh_from_db()
        return article

    # Content extraction
    def fetch_content(self):
        if self.lang != "NA":
            article = ArticleParser(url=self.url, language=self.lang.lower())
        else:
            article = ArticleParser(url=self.url)

        if self.original_status >= 400:
            return

        article.download()
        try:
            article.throw_if_not_downloaded_verbose()
        except ArticleException:
            self.original_status = 400
            self.save()
            return

        article.parse()
        self.title = article.title
        self.extracts = article.text
        self.save()

    def fetch_metadata(self):
        import opengraph_py3 as og

        if self.original_status < 400:
            metadata = og.OpenGraph(url=self.url, )
            self.metadata = metadata.to_json()
            self.save()

    def fetch_image(self):
        import requests
        import imghdr

        if self.lang != "NA":
            article = ArticleParser(url=self.url, language=self.lang.lower())
        else:
            article = ArticleParser(url=self.url)

        if self.original_status >= 400:
            return

        article.download()
        try:
            article.throw_if_not_downloaded_verbose()
        except ArticleException:
            self.original_status = 400
            self.save()
            return

        article.parse()

        img_path = article.meta_img
        if img_path:
            resp = requests.get(img_path, stream=True)
            if resp.status_code == requests.codes.ok:
                fp = BytesIO()
                fp.write(resp.content)

                file_name_ext = imghdr.what(None, resp.content)

apps/rp/api/views.py
from django.db.models import Q

from rest_framework import viewsets, mixins
from djangorestframework_fsm.viewset_mixins import get_drf_fsm_mixin

from rp.models import Article
from rp.views.articles import ArticleFilterMixin

from .serializers import ArticleSerializer

ArticleMixin = get_drf_fsm_mixin(Article, fieldname='status')


class ArticleViewSet(ArticleMixin, ArticleFilterMixin, viewsets.ModelViewSet):
    """
    articles:
    This viewset describes all the method usable on the API
    using Article.

    The RequestBody is only needed for the create, update and partial_update
    functions.

    You can add query parameters to do some filtering, Those are :
        q="search terms" # to do a plaintext search into the title and extract
                         # of articles
        archive="true|[false]|both" # to filter on the archive flag or to
                                    # disable filtering on this flag.
        speak="true|false|[both]" # to filter on the speak flag, or to disable
                                  # filtering on this flag.
        quote="true|false|[both]" # to filter on the quote flag, or to disable
                                  # filtering on this flag.

    list:
    List all known articles in database.

    permissions ```None```

    create:
    Create an article from its URL and inserts it with the
    status _NEW_. If the article already exists, it is upvoted
    by one, and the tags are merged (in case new tags are given
    to this command).

    permissions ```None```

    read:
    Get a specific article by id.

    permissions ```None```

    update:
    Change the content of an article.

    permissions ```rp.can_edit```

    partial_update:
    Change only some fields of an article.

    permissions ```rp.can_edit```

    downvote:
    Decrement the score of an article by one. If the score goes below the
    ```ARTICLE_SCORE_THRESHOLD```, the article will stay in _DRAFT_ state.

    permissions ```rp.can_vote```

    upvote:
    Increment the score of an article by one. It it goes above the
    ```ARTICLE_SCORE_THRESHOLD```, its state will change to _DRAFT_.

    permissions ```rp.can_vote```

    recover:
    Force an Article status at _DRAFT_. It is used to recover _REJECTED_
    articles or ones with a score below ```ARTICLE_SCORE_THRESHOLD```.

    permissions ```rp.can_change_status```

    publish:
    Change the state of a _DRAFT_ article to _PUBLISHED_

    permissions ```rp.can_change_status```

    reject:
    Force an article status to _REJECTED_. It can only be brought back with
    the recover function.

    permissions ```rp.can_change_status```

    set_priority:
    Set the boolean priority of an article to True.

    permissions ```rp.can_change_priority```

    unset_priority:
    Set the boolean priority of an article to False.

    permissions ```rp.can_change_priority```

    set_flags:
    Set the boolean value of flags of an article. The flags are given as a
    dictionary of boolean such as :
        { 'quote': True, 'speak': False, 'archive': False }

    There is currently no other flags.

    permissions ```rp.can_edit```
    """
    queryset = Article.objects.all()
    serializer_class = ArticleSerializer


class ArticleSearch(viewsets.ModelViewSet, mixins.ListModelMixin):
    queryset = Article.objects.all()
    serializer_class = ArticleSerializer

    def list(self, request, *args, **kwargs):
        self.queryset = self.queryset.filter(Q(title__icontains=kwargs['search_keywords'])
                                             | Q(extracts__icontains=kwargs['search_keywords']))
        return super().list(request, args, kwargs)


class ArticleTag(viewsets.ModelViewSet, mixins.ListModelMixin):
    queryset = Article.objects.all()
    serializer_class = ArticleSerializer

    def list(self, request, *args, **kwargs):
        self.queryset = self.queryset.filter(tags__name__in=[kwargs['filter_tag']]).distinct()
        return super().list(request, args, kwargs)


class ArticleStatus(viewsets.ModelViewSet, mixins.ListModelMixin):
    queryset = Article.objects.all()
    serializer_class = ArticleSerializer

    def list(self, request, *args, **kwargs):
        self.queryset = self.queryset.filter(status=kwargs['filter_status'].upper())
        return super().list(request, args, kwargs)

apps/rp/templates/rp/article_detail.html
{% extends "base.html" %}
{% load static %}
{% load crispy_forms_tags %}
{% load crispy_forms_field %}
{% load md2 %}


{% block content-banner %}
{% endblock %}

{% block content %}
<div class="row">
<div class="col-md-12 white-bg">
  <div class="well">

    <div class="d-flex justify-content-start align-items-baseline mb-4">
      <p class="lead">
        <a class="btn btn-outline-primary" href="{% url 'rp:article-list' filter_view='draft' %}">
          <i class="fa fa-chevron-left" aria-hidden="true"></i> Pending articles
        </a>
        {% if object.status == 'PUBLISHED' %}
        <span class="ml-2"><strong>Article ID #{{object.id}} published on {{ object.published_at|date:"DATETIME_FORMAT" }}</strong></span>
        {% else %}
        <span class="ml-2"><strong>Article ID #{{object.id}}</strong></span>
        {% endif %}
      </p>
      <div class="ml-auto">
        <span class="btn-group" role="group" aria-label="Actions">
          {% if object.status == 'PUBLISHED' %}
          <a class="btn btn-outline-danger" href="{% url 'rp:article-edit' object.id %}">Edit</a>
          {% if perms.rp.can_change_status %}
          <a class="btn btn-outline-default" href="{% url 'api:article-unpublish' object.id %}">UnPublish</a>
          <a class="btn btn-outline-danger" href="{% url 'api:article-reject' object.id %}">Reject</a>
          {% endif %}
          {% else %}
          <a class="btn btn-outline-primary" href="{% url 'rp:article-edit' object.id %}">Edit</a>
          {% if perms.rp.can_change_status %}
          <a class="btn btn-outline-warning" href="{% url 'api:article-publish' object.id %}">Publish</a>
          <a class="btn btn-outline-danger" href="{% url 'api:article-reject' object.id %}">Reject</a>
          <a class="btn btn-outline-default" href="{% url 'api:article-recover' object.id %}">Recover</a>
          {% endif %}
          {% endif %}
        </span>
      </div>
    </div>

    <div class="row">
      <div class="col-sm-4"=>
        {% if object.screenshot %}
        <img class="img-fluid mb-4"
             src="/media/{{ object.screenshot }}">
        {% endif %}
      </div>
      <div class="col-sm-8 lead">
        <h4><a target="_blank" href="{{object.url}}">{{object.title}}</a></h4>
        <p>{{article.created_at.date}}
        {% for t in article.tags.all %}
        <span class="badge badge-default ml-1">{{t}}</span>
        {% endfor %}
        </p>
        {% if article.archive %}
        <span class="badge badge-info ml-1"><span class="glyphicon glyphicon-floppy-disk" aria-label="{{ _("Archived") }}"></span>
        {% endif %}
        {% if article.quote %}
        <span class="badge badge-info ml-1"><span class="glyphicon glyphicon-comment" aria-label="{{ _("Quotes us") }}"></span>
        {% endif %}
        {% if article.speak %}
        <span class="badge badge-info ml-1"><span class="glyphicon glyphicon-bullhorn" aria-label="{{ _("Speaks about us") }}"></span>
        {% endif %}

        <h4>{{ _("Article created by:") }}&nbsp;<em>{{ article.created_by }}</em></h4>
        <p>
        <a target="mailto:{{ article.created_by.user.email }}"><span class="glyphicon glyphicon-envelope" aria-label="{{ _("Contact this user by email")}}"></span>
        </p>
        <p>{{object.extracts |markdown}}</p>
        {% if perms.rp.can_vote %}
        <span>
            <a href="{% url 'api:article-upvote' object.id  %}" class="btn btn-outline-default">+1</a>
            <a href="{% url 'api:article-downvote' object.id  %}" class="btn btn-outline-default">-1</a>
        </span>
        {% endif %}
      </div>
    </div>

</div>
</div>
{% endblock %}

apps/rp/templates/rp/article_form.html
{% extends "base.html" %}
{% load static %}
{% load crispy_forms_tags %}
{% load crispy_forms_field %}


{% block content-banner %}
{% endblock %}

{% block content %}
<div class="row">
<div class="col-md-12 white-bg">
  <div class="well">

  <form class="" action="#" method="post">

    <div class="d-flex justify-content-start align-items-baseline mb-4">
      <p class="lead">
        <a class="btn btn-outline-primary" href="{{request.META.HTTP_REFERER}}"><i class="fa fa-chevron-left" aria-hidden="true"></i> Go back</a>
        {% if object.status == 'PUBLISHED' %}
        <span class="ml-2"><strong>Article ID #{{object.id}} published on {{ object.published_at|date:"DATETIME_FORMAT" }}</strong></span>
        {% else %}
        <span class="ml-2"><strong>Article ID #{{object.id}}</strong></span>
        {% endif %}

        <a class="btn btn-outline-primary" href="?fetch_content">Fetch content</a>
        <a class="btn btn-outline-primary" href="?fetch_image">Fetch image</a>
        <a class="btn btn-outline-primary" href="?fetch_metadata">Fetch metadata</a>
      </p>
      <div class="ml-auto">
        <span>Save and&nbsp;</span>
        <span class="btn-group" role="group" aria-label="Actions">
          {% if object.status == 'PUBLISHED' %}
          <input type="submit" class="btn btn-outline-danger" name="view" value="View">
          {% else %}
          <input type="submit" class="btn btn-outline-primary" name="preview" value="Preview">
          <input type="submit" class="btn btn-outline-warning" name="publish" value="Publish">
          {% endif %}
        </span>
      </div>
    </div>

    {% crispy form %}
  </form>
</div>
</div>

<script type="text/javascript">
  $('[name=tags]').select2({
    tags: true,
    tokenSeparators: [',', ' '],
    theme: "bootstrap"
  });
  $('.select2-container').width("auto");

  var simplemde = new SimpleMDE({
    element: $("#id_extracts")[0],
    toolbar: ["bold", "italic", "strikethrough", "|", "heading", "quote", "link", "|", "side-by-side", "preview", "guide"],
    spellChecker: false,
    blockStyles: {
      bold: "**",
      italic: "_"
    },
  });
</script>
{{ form.media }}
{% endblock %}

apps/rp/templates/rp/article_list.html
{% extends "base.html" %}


{% block content-header %}
<div class="row justify-content-left">
  <div class="col-md-6 offset-md-1">
    <h4>Participez à l'aventure !</h4>
    <p>En tant que padawan
      <img class="inline-image" role="img" src="{% static 'img/padawan.svg' %}" />,
      aidez-nous à sélectionner les prochains articles à intégrer dans la
      revue de presse en votant pour les meilleurs. Les jedis
      <img class="inline-image" role="img" src="{% static 'img/jedi.svg' %}" />
      s'occupent ensuite de la relecture et de la mise en page des articles.
    </p>

    <p>Faites-vous connaître sur le
      <a target="_blank" href="https://www.laquadrature.net/wiki/IRC">salon IRC #lqdn-rp</a>
      où il vous sera fait bon accueil, ou en nous
      <a target="_blank" href="https://www.laquadrature.net/fr/contact">contactant par email</a>.
    </p>
  </div>
  <div class="col-md-4">
    <h4>Comment sélectionner un article ?</h4>
  <ol>
    <li>Il aborde les sujets sur lesquels La Quadrature est engagée (paquet télécom, ACTA, <i>etc.</i>).</li>
    <li>Il reflète ou appuie l'avis de La Quadrature.</li>
    <li>Il provient prioritairement de médias importants (presse nationale, régionale ou internationale).</li>
  </ol>

  </div>
</div>
{% endblock %}

{% block content %}
<div class="row">
<div class="col-md-12 white-bg">
  <ul class="nav nav-integrated">
    <li class="nav-item{% if filter_view == 'flux' %} active{% endif %}">
      <a class="nav-link" href="{% url 'rp:article-list' filter_view='flux'%}">
          Flux <span class="glyphicon glyphicon-piggy-bank" aria-hidden="true"></span>
      </a>
    </li>
    <li class="nav-item {% if filter_view == 'draft' %} active{% endif %}">
      <a class="nav-link" href="{% url 'rp:article-list' filter_view='draft'%}">
        En attente <span class="badge badge-default">{{nb_draft}}</span>
      </a>
    </li>
    <li class="nav-item {% if filter_view == 'published' %} active{% endif %}">
      <a class="nav-link" href="{% url 'rp:article-list' filter_view='published'%}">Publiés</a>
    </li>
  </ul>

  <div class="well">
    {% if is_paginated %}
      <div class="pagination">
        <span class="page-links">
          {% if page_obj.has_previous %}
            <a href="?page={{ page_obj.previous_page_number }}"><i class="fa fa-chevron-left" aria-hidden="true"></i></a>
          {% endif %}
          <span class="page-current">
            Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}
          </span>
          {% if page_obj.has_next %}
            <a href="?page={{ page_obj.next_page_number }}"><i class="fa fa-chevron-right" aria-hidden="true"></i></a>
          {% endif %}
        </span>
      </div>
    {% endif %}

    {% if filter_view == "rejected" %}
      <div class="alert alert-danger" role="alert">
        {% trans "Rejected articles" %}
      </div>
    {% endif %}

    <table class="article-table table table-sm my-4">
      <thead>
        <tr>
          {% if filter_view != "published" %}<th>Priority</th>{% endif %}
          <th>ID</th>
          <th>Date</th>
          <th>Language</th>
          <th>Title</th>
          <th>Note</th>
          <th>Added&nbsp;by</th>
          <th>Archived</th>
          <th>Quotes us</th>
          <th>Speak of us</th>
          <th>Actions<img class="inline-image ml-2" role="img" src="{% static 'img/jedi.svg' %}" /></th>
        </tr>
      </thead>
    <tbody>
    {% for article in object_list|slice:":10" %}
      <tr id="row_empty_{{article.id}}" class="empty-row"><td colspan="8"></td></tr>
      <tr id="row_{{article.id}}">
        {% if filter_view != "published" %}
        <td class="icon-cell actions-item" onclick="javascript:call_priority({{article.id}}, {{article.priority|yesno:"false,true"}})">
          <i id="priority_{{article.id}}" class="fa fa-star{{ article.priority|yesno:",-o" }}" aria-hidden="true"></i>
        </td>
        {% endif %}
        <td>{{article.id}}</td>
        <td>{{article.created_at |date:'d/m/y'}}<br />{{article.created_at |date:'H:i'}}</td>
        <td>{{article.lang}}</td>
        <td class="title-cell"><a target="_blank" href="{{article.url}}"><strong>{{article}}</strong></a></td>
        <td>
            <span id="score_{{article.id}}">{{article.score}}</span>
          {% if filter_view != "published" %}
          <ul class="votes-list">
            <li class="actions-item" onclick="javascript:call_upvote({{article.id}})">
              <i class="fa fa-thumbs-up" aria-hidden="true" style="color:green"></i>
            </li>
            <li class="actions-item" onclick="javascript:call_downvote({{article.id}})">
              <i class="fa fa-thumbs-down" aria-hidden="true" style="color:red"></i>
            </li>
          </ul>
          {% endif %}
        </td>
        <td>{{article.created_by}}</td>
        <td>{{article.archive}}</td>
        <td>{{article.quote}}</td>
        <td>{{article.speak}}</td>
        <td class="actions-cell">
          <ul class="actions-list">
            {% if filter_view == 'flux' %}
            <li class="actions-item actions-item-draft" onclick="javascript:call_recover({{article.id}})">
              <i class="fa fa-fw fa-chevron-right" aria-hidden="true"></i> Forcer
            </li>
            {% else %}
            <li class="actions-item actions-item-edit"><a href="{% url 'rp:article-edit' article.id %}">
              <i class="fa fa-fw fa-pencil" aria-hidden="true"></i> Éditer</a>
            </li>
            {% endif %}
            {% if filter_view != 'published' %}
            <li class="actions-item actions-item-reject" onclick="javascript:call_reject({{article.id}})">
              <i class="fa fa-fw fa-times" aria-hidden="true"></i> Rejeter
            </li>
            {% endif %}
          </ul>
        </td>
      </tr>
      {% if filter_view != 'flux' and article.tags.count %}
      <tr id="row_tags_{{article.id}}" class="tags-row">
        <td colspan="8">
          {% for t in article.tags.all %}
          <span class="badge badge-info">{{t}}</span>
          {% endfor %}
        </td>
      </tr>
      {% endif %}
    {% endfor %}
    </tbody>
    </table>
  </div>
</div>
</div>
{% endblock %}